-- adamius 2019

rail_force="player"

function on_chunk_generated(event)
  
  if event.area.left_top.y == 0 then
    local ex = event.area.left_top.x
    local ey = event.area.left_top.y
    local x = ex
    local y = ey-1 -- for tiles
    local border=16 -- setting
    local killzone = {left_top={x,y-7},right_bottom = {x+32,y+border}}

    -- remove cliffs (and trees but that ... doesn't work)
    for _, enemytype in ipairs({"cliff"}) do
      for _, v in pairs(event.surface.find_entities_filtered{type = enemytype, area = killzone}) do
        v.destroy()
      end
    end
    
    -- enemies
    for _, v in pairs(event.surface.find_entities_filtered{force = "enemy",area = killzone}) do
      v.destroy()
    end

    -- alternative approach to deleting rocks and enemies (delete in 0.0.5)
    if false then
      for _, enemyname in ipairs({"rock-big","rock-huge","tree-02","tree-03","sand-rock-big","stone-rock","tree-09-stump", "tree-09-red", "dead-grey-trunk","dead-tree", "dark-thin-tree", "dry-tree", "green-thin-tree", "dark-green-thin-tree", "red-thin-tree", "green-tree", "dark-green-tree", "red-tree", "root-tree", "green-coral", "dead-grey-trunk", "dry-hairy-tree", "dead-dry-hairy-tree", "spitter-spawner", "biter-spawner", "small-worm-turret", "medium-worm-turret", "big-worm-turret"}) do 
        for _, entity in ipairs(event.surface.find_entities_filtered{area = killzone, name = enemyname}) do 
          entity.destroy() 
        end 
      end   
    end
    
    -- get rid of rocks and trees 
    for _, entity in ipairs(event.surface.find_entities_filtered{area = killzone}) do 
      if entity.valid then
        if entity.name then
          if string.find(entity.name,"rock",1,true) then
            entity.destroy()
          else
            if string.find(entity.name,"tree",1,true) then
              entity.destroy()
            else
              if string.find(entity.name,"trunk",1,true) then
                entity.destroy()
              end
            end
          end
        end
      end
    end 
    
    -- test -455,0 on 1846121408
    -- report on what survived
    if false then
      for _, entity in ipairs(event.surface.find_entities_filtered{area = killzone}) do 
        game.players[1].print(entity.name) 
      end
    end
    
    -- decoratives shouldn't poke through concrete
    event.surface.destroy_decoratives(killzone)
    
    -- place concrete
    -- don't place landfill underneath in case players want the water.
    y = ey-1
    local tiles = {}
    for dy = -7,16 do
      for dx = 0,31 do
        table.insert(tiles, {name = "refined-concrete", position = {x+dx,y+dy}}) 
	  end
    end
    event.surface.set_tiles(tiles)
    
    x = ex
    y = ey
    for dx = 0,15 do
     
      if math.fmod(x+dx*2,30)==0 then
        event.surface.create_entity({
        name= "big-electric-pole",
        position = {x+dx*2,y+4},
        force = rail_force
        })
        
        event.surface.create_entity({
        name = "rail-signal",
        position = {x+dx*2,y-1},
        force = rail_force,
        direction = defines.direction.east
        })
        
        event.surface.create_entity({
        name = "rail-signal",
        position = {x+dx*2,y+8},
        force = rail_force,
        direction = defines.direction.west
        })
        
		 event.surface.create_entity({
        name = "rail-signal",
        position = {x+dx*2,y-7},
        force = rail_force,
        direction = defines.direction.east
        })
        
        event.surface.create_entity({
        name = "rail-signal",
        position = {x+dx*2,y+14},
        force = rail_force,
        direction = defines.direction.west
        })
		
      end
    
      event.surface.create_entity({
      name = "straight-rail",
      position = {x+dx*2, y},
      force = rail_force,
      direction = defines.direction.east
      })

      event.surface.create_entity({
      name = "straight-rail",
      position = {x+dx*2, y+6},
      force = rail_force,
      direction=defines.direction.east
      })
      
	   event.surface.create_entity({
      name = "straight-rail",
      position = {x+dx*2, y-6},
      force = rail_force,
      direction = defines.direction.east
      })

      event.surface.create_entity({
      name = "straight-rail",
      position = {x+dx*2, y+12},
      force = rail_force,
      direction=defines.direction.east
      })
	  
    end
    
  end
  
end

script.on_event(defines.events.on_chunk_generated, on_chunk_generated)

